use crate::compositions;
use beteran_protobuf_rust as bpr;

impl From<&compositions::betting::models::BettingHistoryModel>
  for bpr::models::api::betting::BettingHistoryModel
{
  fn from(d: &compositions::betting::models::BettingHistoryModel) -> Self {
    let member = Some(bpr::models::member::Member {
      id: d.member.id.to_string(),
      site_id: d.member.site_id.to_string(),
      member_class_id: d.member.member_class_id.to_string(),
      member_level_id: d.member.member_level_id.to_string(),
      parent_member_id: d.member.parent_member_id.as_ref().map(|d| d.to_string()),
      child_member_count: d.member.child_member_count as u64,
      username: d.member.username.clone(),
      nickname: d.member.nickname.clone(),
      mobile_phone_number: d.member.mobile_phone_number.clone(),
      state: d.member.state as i32,
      state_changed_at: d.member.state_changed_at.map(|d| d as u64),
      last_signined_ip: d.member.last_signined_ip.clone(),
      last_signined_at: d.member.last_signined_at.map(|d| d as u64),
      created_at: d.member.created_at as u64,
      updated_at: d.member.updated_at as u64,
      deleted_at: d.member.deleted_at.map(|d| d as u64),
    });

    bpr::models::api::betting::BettingHistoryModel {
      id: d.id.clone(),
      member,
      vendor_id: d.vendor_id as u64,
      vendor_name: d.vendor_name.clone(),
      game_id: d.game_id as u64,
      game_name: d.game_name.clone(),
      game_category: d.game_category.clone(),
      game_type: d.game_type.clone(),
      currency: d.currency.clone(),
      cash: d.cash,
      before_cash: d.before_cash,
      after_cash: d.after_cash,
      key: d.key.clone(),
      ref_id: d.ref_id.clone(),
      o_ref_id: d.o_ref_id.clone(),
      group_key: d.group_key.clone(),
      is_bonus: d.is_bonus,
      is_promo: d.is_promo,
      is_jackpot: d.is_jackpot,
      site_username: d.site_username.clone(),
      betting_type: d.betting_type.clone(),
      category: d.category.clone(),
      created_at: d.created_at as u64,
      utc_created_at: d.utc_created_at as u64,
    }
  }
}
